<?php

namespace App\Jobs;

use App\Services\LogService;
use App\Services\OrderService;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Database\Eloquent\Collection;
use Illuminate\Database\QueryException;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;

class OrderCreateInstantBill implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable;


    protected $orders;
    /**
     * Create a new job instance.
     *
     * @param Collection $orders
     * @return void
     */
    public function __construct($orders)
    {
        $this->orders = $orders;
    }

    /**
     *
     * @param OrderService $service
     * @return void
     * @throws
     */
    public function handle(OrderService $service)
    {
        if ($this->orders){
            $errors = [];
            foreach ($this->orders as $order){
                try{
                    if (!$service->createInstantBill($order))
                        LogService::log(__METHOD__,"ERROR-订单生成即时账单",$order->toJson());
                }catch(QueryException $qe){
                    if ($qe->getCode()!='23000'){
                        LogService::log(__METHOD__,"ERROR-订单生成即时账单",$order->toJson()." | ".$qe->getMessage());
                        $errors = ["order_".$order->id.":".$qe->getMessage()];
                    }
                }catch (\Exception $e){
                    LogService::log(__METHOD__,"ERROR-订单生成即时账单",$order->toJson()." | ".$e->getMessage());
                    $errors = ["order_".$order->id.":".$e->getMessage()];
                }
            }
            if ($errors)throw new \Exception(json_encode($errors));
        }
    }
}
